package guikit;
//TATA Playing with CVS
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;

import neuroml.util.*;
import neuroml.core.*;


/** A simple About dialog with image + text + OK button.
 */
public class AboutPanel implements ActionListener {
 
    
    JFrame dialog;
   
    /** Build an About dialog with given image
     */
    public AboutPanel(String title, Image image, String message) {
 
	// Make a frame, with OK/Cancel
	dialog = new JFrame(title);
	dialog.getContentPane().setLayout( new BoxLayout(dialog.getContentPane(),BoxLayout.Y_AXIS));

	JPanel fields = new JPanel();
	fields.setLayout( new BoxLayout(fields, BoxLayout.Y_AXIS) );
	if (image != null) {
	    JPanel pic = new JPanel(); pic.setLayout(new FlowLayout( ));
	    fields.add(pic);
	    pic.add( new JLabel(new ImageIcon(image)));
	}
	fields.add( new JLabel(message));

	
	JPanel buttons = new JPanel();
	// buttons.setLayout( new BoxLayout(buttons, BoxLayout.Y_AXIS) );
	buttons.add(EditPanel.makeButton("OK", "ok", this));
	dialog.getContentPane().add(fields);
	dialog.getContentPane().add(buttons);
	dialog.pack();
    }     

    public void popup() {
	dialog.setVisible(true);
    }

    public void actionPerformed(java.awt.event.ActionEvent e) {
	if (e.getActionCommand().equals("ok")) {
	    dialog.setVisible(false);	  
        }
    }
 
}

