
package guikit;


import java.awt.event.*;

import java.awt.*;
import java.util.*;
import javax.swing.*;



   
/** Windows manager : register all windows so they can be disposed of at once
 */
public class WindowManager {
    private static Vector windows = new Vector();   // windows

   
    /** Set resources, top frame
     */
    public WindowManager() {

    }

    public static void registerWindow(Window w){
	//System.out.println("registerWindow "+w);
	windows.addElement(w);
    }
    public static void disposeAll(){
	for(int i=windows.size()-1;i>=0;i--){
	    Window w = (Window)windows.elementAt(i);
	    //System.out.println("dispose Window "+w);

	    if (w!=null)
		w.dispose();
	}
    }
   public static void disposeAllOthers(Window me){
	for(int i=windows.size()-1;i>=0;i--){
	    Window w = (Window)windows.elementAt(i);
	    //System.out.println("dispose Window "+w);

	    if (w!=null)
		if (w!=me) w.dispose();
	}
    }
    public static void hideAll(){
	for(int i=windows.size()-1;i>=0;i--){
	    Window w = (Window)windows.elementAt(i);
	    //System.out.println("hide Window "+w);

	    if (w!=null)
		w.setVisible(false);
	}
    }
    public static void hideAllOthers(Window me){
	for(int i=windows.size()-1;i>=0;i--){
	    Window w = (Window)windows.elementAt(i);
	    //System.out.println("hide Window "+w);

	    if (w!=null)
		if (w!=me) w.setVisible(false);
	}
    }


}
