/*
 * Source_FirstOnly.java
 *
 * Created on 11 February 2004, 15:50
 */

package Holger_modules.module.Source_FirstOnly;
import Holger_modules.module.sourcemethod.SpikeSourceMethod;
import neuroml.sim.state.*;
import neuroml.sim.run.*;
import neuroml.util.module.*;
import java.awt.*;
import java.awt.geom.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class Source_FirstOnly extends SpikeSourceMethod {
    
    /** Creates a new instance
     of Source_FirstOnly */
    public int cellCID=0;
    public Source_FirstOnly() {
    }
    
     public void sendRequests(ConnectionRequestSender crs, ElementState srcState, PopulationState dstState, DestMethod dm,boolean BuildingConnection){       
         if(((BasicRunnableCell)srcState).getIndex()!=cellCID) //getID
         {
             //System.out.println("DEBUG DISCARD: "+srcState.getID());
             return;
         }
         for (int i=0; i<dstState.getNumElements(); i++) {
		ConnectionRequest cr = new ConnectionRequest(srcState.getID(), 
							     srcPort, 
							     dm);
		//info about source cr.setSrcData( srcpos );
		crs.sendRequest(cr, dstState.getElementID(i),BuildingConnection);	    
	    }
    }
    public void Draw(Graphics2D g, double x, double y){
        g.setColor(Color.BLUE.darker());
        g.fill(new Rectangle2D.Double(x-16,  y-16, 32,32));
        g.setColor(Color.white);
        g.fill(new Rectangle2D.Double(x-2,  y-8, 4,16));
        g.fill(new Rectangle2D.Double(x-3,  y-9, 6,1));
        g.fill(new Rectangle2D.Double(x-4,  y-11, 8,2));
        g.fill(new Rectangle2D.Double(x-3,  y+8, 6,1));
        g.fill(new Rectangle2D.Double(x-4,  y+9, 8,2));
    }
}
