/*
 * ArrayPosition3D.java
 *
 * Created on 13 July 2004, 17:14
 */

package Holger_modules.module.position;
import neuroml.model.network.PositionModule;
import neuroml.core.NeuromlArray;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class ArrayPosition3D implements PositionModule{
    public NeuromlArray NeuronsPosition;
    /** Creates a new instance of ArrayPosition3D */
    public ArrayPosition3D() {
        NeuronsPosition=new NeuromlArrayPosition3D();
    }
    
    public int getSize() {
        return (NeuronsPosition.size()/3);
    }
    
    public void setEntityPos(neuroml.sim.state.PositionState e, int index) {
        Double X=(Double)(NeuronsPosition.elementAt(index*3)),Y=(Double)(NeuronsPosition.elementAt(index*3+1)),Z=(Double)(NeuronsPosition.elementAt(index*3+2));
        //,Y=(int)(NeuronsPosition.elementAt(index*3+1)),Z=(int)(NeuronsPosition.elementAt(index*3+2));
        e.setPos(X.doubleValue(), Y.doubleValue(), Z.doubleValue());
    }
    
}
