package neosim.iface;

/**  A connection links a source entity/port to a destination entity/port,
 * and has a delay. It is possible to check the connection details for events 
 * arriving on a port to get the delay, and source entity/port.
 * ConnectionIDs are assigned when the addInConnection() method of the
 * destination entity is called.
 */
public interface Connection extends java.io.Serializable {
   /* public EntityID     getDstEntityID();
    public PortID       getDstPortID();
    public Time         getDelay();
    public EntityID     getSrcEntityID();
    public PortID       getSrcPortID();
    public ConnectionID getConnectionID();
    public void         setConnectionID(ConnectionID c);

    public void sendEvent( Event ev );*/
    
    public int  getDstEntityID();
    public short  getDstPortID();
    public long getDelay();
    public int  getSrcEntityID();
    public short getSrcPortID();
    public int getConnectionID();
    public void setConnectionID(int c);

    public void sendEvent( Event ev );
    public void addSpike(long time);
}
