

package neosim.iface;

/**  A population builder builds a number of entities of
 * a given class and initialises each one according to
 * its index in the population.
 */
public interface PopulationBuilder extends Population {
  
    /** Return the entity initialisation method */
    public EntityInit  getEntityInit();

    /** Return the entity class of the population */
    public EntityClass getEntityClass();
}
