/*
 * InportsTableOut.java
 *
 * Created on 16 February 2005, 18:03
 */

package neosim.implementation;
import neosim.util.SmallLists.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class InportsTableOut extends LinkedList {
    InportsTableOut next=null;  
    LinkedListSrcPort_Out Array[];  
    boolean Compressed=false;
    /** Creates a new instance of InportsTableOut */
    public InportsTableOut() {
        Array=new LinkedListSrcPort_Out[this.ListSize];
        LinkedList.TotalMemoryLinkedLists+=this.getSize();            
    }
    
    public void compress() {
        for(int i=0;i<RealIndex_read;i++){
		if(Array[i]!=null){
                 //   neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
                 //   neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);
                    Array[i].compress();
                 //   neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp); 
                }
        }
        if(next!=null)
            next.compress();            
    }    
    
  /*  public synchronized void check_compressed(){
        if(!Compressed)
            try{
                System.out.println("Waiting");//ASSERT
                compress_final();
                //wait();
            }
            catch(Exception e){
                e.printStackTrace();
            }
            System.out.println("Finished Waiting");//ASSERT
    }*/
    
    public  void compress_final() {
     //   System.out.println("NbConns = "+nbconn+" ConRequested = "+ neuroml.sim.run.ConnectionRequest.nbconnSent+" DestMethod = "+neosim.neuroml.NeosimDestMethodImpl.nbconns+" NeuromlConnectionMaker "+neosim.neuroml.NeuromlConnectionMaker.nbconns+" BasicKernel "+neosim.kernel.BasicKernel.nbconns+" addIn1 "+neosim.implementation.EntityImpl.nbconns1+" addIn2 "+neosim.implementation.EntityImpl.nbconns2);
   //     neosim.kernel.Deadlock_Message ecp0=new neosim.kernel.Deadlock_Message();
   //     neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp0);   
        
   //     neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
   //     neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);         
        synchronized(this){
   //         neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);             
            if(Compressed)
                return;
            Compressed=true;
            InportsTableOut stuff=this;
            short MaxPortIn=-1;
            short current;
            int TotalLength=0;
            do{
                for(int i=0;i<stuff.RealIndex_read;i++){
                    if(stuff.Array[i]!=null){
                        current=stuff.Array[i].getID();
                        if(current>MaxPortIn)
                            MaxPortIn=current;
                    }
                }
                TotalLength+=stuff.getSize();
                stuff=stuff.next;
            }while(stuff!=null);
        
            LinkedListSrcPort_Out[] NewArray=new LinkedListSrcPort_Out[MaxPortIn+1];
        
            stuff=this;
            do{
                for(int i=0;i<stuff.RealIndex_read;i++){
                    if(stuff.Array[i]!=null)
                        NewArray[stuff.Array[i].getID()]=stuff.Array[i];
                }
                stuff=stuff.next;
            }while(stuff!=null);
        
            Array=NewArray;
            this.ListSize=MaxPortIn+1;
            LinkedList.TotalMemoryLinkedLists=getSize()+LinkedList.TotalMemoryLinkedLists-TotalLength;
            next=null;
            this.RealIndex_read=ListSize;

            //neosim.kernel.Deadlock_Message ecp2=new neosim.kernel.Deadlock_Message();
            //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp2);              
            
            for(int i=0;i<RealIndex_read;i++){
                if(Array[i]!=null)
                    Array[i].compress_final();
            }      
            
            //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp2);
        }
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp0);                     
         
       // notify();
    }
    static public int nbconn=0;
    public int addOutConnection(short srcPort, short destPort, int srcID){
        int return_value=-1;
        nbconn++;
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);        
        
        synchronized(this){
            //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);
            //neosim.kernel.Deadlock_Message ecp2=new neosim.kernel.Deadlock_Message();
            //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp2);
            Compressed=false;
            for(int i=0;i<RealIndex_read;i++){
                if(Array[i]!=null&&Array[i].getID()==srcPort){
                  return_value=Array[i].addOutConnection(destPort,srcID);
                }
            }
            
            //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp2);
            if(return_value!=-1)
                return return_value;
            
            if(RealIndex_read==this.ListSize){
              if(next==null)
                next=new InportsTableOut();
                //neosim.kernel.Deadlock_Message ecp3=new neosim.kernel.Deadlock_Message();
                //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp3);  
                return_value=next.addOutConnection(srcPort,destPort, srcID); 
                //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp3);
            }
            else{
                Array[RealIndex_read]=new LinkedListSrcPort_Out(srcPort);
                //neosim.kernel.Deadlock_Message ecp3=new neosim.kernel.Deadlock_Message();
                //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp3);                
                return_value=Array[RealIndex_read++].addOutConnection(destPort,srcID);
                //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp3);
            }
        }
        return return_value;
    }  
    
    public int getSize() {
        return 28+Array.length<<2;        
    }
    
    public int NumberPerPort(short inport,short destport) {//dont care about the port {//dont care about the port
        int k=0;
        InportsTableOut stuff=this;
        do{
            for(int i=0;i<stuff.Array.length;i++ ){
                if(stuff.Array[i]!=null)
                    k+=stuff.Array[i].NumberPerPort(destport);
            }
            stuff=stuff.next;
        }while(stuff!=null);
        return k;        
    }
    public void  deleteInConnection(short SrcPortID, short destPortID, int srcID) {//ConnectionID cid
         neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
         //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);          
        Array[SrcPortID].deleteInConnection(destPortID,srcID);
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp); 
        //inconnections
    }
    
    public int[][] getInConnection(short SrcPortID){
        int[][] reutrn_value;
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);      
        synchronized(this){
             //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp); 
             //neosim.kernel.Deadlock_Message ecp1=new neosim.kernel.Deadlock_Message();
             //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp1);                   
            if(!Compressed)
                compress_final();
             //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp1); 
             //neosim.kernel.Deadlock_Message ecp2=new neosim.kernel.Deadlock_Message();
             //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp2);             
            if(SrcPortID<Array.length&&Array[SrcPortID]!=null)
                reutrn_value=Array[SrcPortID].getOutConnection((short)-1);
            else
                reutrn_value=new int[0][0];
             //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp2); 
        }
        return reutrn_value;
    }
}
