package neosim.kernel;

/** Reset a simulation 
 */
public class ResetCommand extends QueryCommand {
    public final String getType() { return "Reset Command"; }
    public ResetCommand(int id) { 
	super(id); 
	setBlocking(true);
    }
    public final void doit(SimKernel sk, Collective comms) throws ResetException {  
	sk.resetRmt(id);
//JAG DANGEROUS OPTIMIZATION                 
	//if (needResponse()) sk.sendCommand(id, new QueryResponse(sk.getID(), qid, new Integer(0)));
        if (needResponse()) sk.sendCommand(id, new QueryResponseInteger(sk.getID(), qid, new Integer(0)));
    }
}
