package neosim.kernel;

import java.rmi.*;
import neosim.iface.Time;

/** The interface to a remote processor
 */
public interface RmtProc extends java.rmi.Remote {
  public int getID() throws java.rmi.RemoteException; 
  void setState(int i) throws java.rmi.RemoteException; 
  int  getState_() throws java.rmi.RemoteException; 
  void restart() throws java.rmi.RemoteException;  
  void pauseme() throws java.rmi.RemoteException; 
  void setGoing() throws java.rmi.RemoteException;   
  void setID(int id)  throws java.rmi.RemoteException; 
  void poison()  throws java.rmi.RemoteException;
  Time getRightWindowTime() throws java.rmi.RemoteException;
  void setRightWindowTime(Time t) throws java.rmi.RemoteException;

}
