package neosim.neuroml;

import neosim.iface.*;
import neosim.implementation.*;
import java.util.Hashtable;
import java.util.*;
import neuroml.sim.run.*;

/**
 * Neuroml converter
 *  utility functions that allows Neosim to communicate with NeuroML control modules
 * @author Paul Rogister
 * @date Aug 2001
 */
public final class NeosimControlModuleImpl extends ControlModuleImpl {

    neuroml.sim.run.RunnableControl rc;
    
    public NeosimControlModuleImpl() {}

    public NeosimControlModuleImpl(neuroml.sim.run.RunnableControl rc) {
	this.rc = rc;
    }

    /** Initialise given the parameters
     * @param params the hashtable of parameters (strings)
     * @deprecated
     */
    public void init(Hashtable params) {
	//	rc.init(params);
    }

    /** Perform simulation tasks
     * @param sr the script reader
     */
    public void run( ScriptReader sr ) {
	neosim.neuroml.NeuromlSimulator sim = new neosim.neuroml.NeuromlSimulator(sr);
        Class c=sim.getClass();
        Class c2=neosim.neuroml.NeuromlSimulator.class;
	rc.run(sim);
    }  
}
