/*
 * Barrier.java
 *
 * Created on 10 March 2005, 17:12
 */

package neosim.rmikernel;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class Barrier {
    int narrived=0;
    int ntot;    
    /** Creates a new instance of Barrier */
    public Barrier(int ntot) {
        this.ntot=ntot;        
    }
    public synchronized void barrier(){
        narrived++;
        if(narrived==ntot){
            notifyAll();
            narrived=0;
        }
        else{
            try{
               wait();
            }
            catch(java.lang.InterruptedException e){
                System.out.println("Error "+narrived);
                e.printStackTrace();
            }
        }        
    }    
}
