package neosim.util.loaders.jarload;

import neosim.iface.*;
import neosim.implementation.ScriptReaderImpl;
import neosim.util.*;

import java.util.Vector;
import java.beans.*;
import neuroml.sim.run.*;


/** Init ScriptReader bean 
 * @author Fred Howell
 * @version 1.0 
 * @version 1.1 - Modifications for RMI version
 */
public class ScriptBean implements DoOnBean {
    boolean debug = false;

    String[] args;
    ScriptBean(String[] args) { super(); this.args = args;  }

    public void action(JarInfo ji, BeanInfo bi, String beanName) {
	if (debug) System.out.println("Script running "+beanName);
	/*ScriptReaderImpl sr = (ScriptReaderImpl)ji.getInstance(beanName);

	sr.initKernel(args); 
	if (debug) System.out.println("ScriptBean done init");

	if (sr.needToConstruct()) {
	    sr.bootstrap(args);
	    sr.destroyKernel();
	}*/
        Simulator sr = (Simulator)ji.getInstance(beanName);

	sr.initKernel(args); 
	if (debug) System.out.println("ScriptBean done init");

	//if (sr.needToConstruct()) {
	    sr.bootstrap(args);
	//    sr.destroyKernel();
	//}
        
	if (debug) System.out.println("ScriptBean done destroy");
    }
    public void error(String msg) {
	System.out.println("Start bean error "+msg);
    }
    public void error(String msg, Exception ex) {
 	System.out.println("Start bean exception "+msg);
   }
}
