package neuroml.core;

/* Log details for an object
 */
public class Log extends NamedObject {
    /** Author of object
     */
    public String author;

    /** Creation date
     */
    public String date;

    /** Reference to paper (to be done differently?)
     */
    public String literatureReference;

    /** list of modifications to an object
     * Each entry contains timestamp, modifier & ref to the tool/version
     */
    public List logEntries = new List("LogEntry");
}
