package neuroml.core;

/* Log details for an object
 */
public class LogEntry extends NamedObject {
    /** Name of the person who made this version
     */
    public String modifiedBy="";

    /** Timestamp of version
     */
    public String timestamp="";

    /** Reference to version/location of 
     * the piece of software which modified this
     * version of the object
     */
    public Ref toolInfo = new Ref("ToolInfo"); 
}
