
package neuroml.core;

/**
 * A probability density function for a uniform distribution
 * between given limits.
 */
public class UniformPDF extends PDF {
    public double min;
    public double max;

    public UniformPDF() {
	this("default", 0.0, 1.0);
    }
    public UniformPDF(String rngName, double min, double max) { 
	super(rngName);
	this.min = min;
	this.max = max;
    }
}
