/*
 * CellVoltage.java
 *
 * Created on 30 September 2004, 16:07
 */

package neuroml.model.MeasurementTool;
import neuroml.sim.run.*;
import neuroml.util.module.*;
import neuroml.core.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class CellVoltage extends MeasurementTool {
  
    /** Creates a new instance of CellVoltage */
    public CellVoltage() {
        super();
    }
    
    public double getValue(RunnableCell myCell, double t) {
        return ((BasicRunnableCell)myCell).getVoltage(t);                
    }
    public String toString(){
        String toAdd;
        if(this.ToBeSent)
            toAdd=new String();
        else
            toAdd=new String("NOT_");
        return toAdd+"V";
    }
    public String getXUnit(){
        return "Time(s)";        
    }
    public String getYUnit(){
        return "Voltage(V)";
    }        
    
    public Object Clone() {
        return new CellVoltage();
    }    
    
}
