/*
 * MeasurementSet.java
 *
 * Created on 18 October 2004, 17:32
 */

package neuroml.model.MeasurementTool;
import neuroml.core.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class MeasurementSet extends neuroml.core.Set{
    
    /** Creates a new instance of MeasurementSet */
    
    /** Creates a new instance of PermanentSet */
    public MeasurementSet() {
        super();
    }
    public MeasurementSet(String str) {
        super(str);
    }
    public PermanentSet Clone(){
        try{
            PermanentSet stuff=new PermanentSet("MeasurementTool");
            stuff.setName(new String(getName()));
            //stuff.type=new String(type);
            for(int i=0;i<elements.size();i++){
                Object o=this.elementAt(i);
                if(o instanceof ModuleMeasurement){
                    o=((ModuleMeasurement)o).module.parameters;
                }
                if(o instanceof Clonable)
                    stuff.add(((Clonable)o).Clone());
                else    
                    stuff.add(o);
            }
            return stuff;
        }
        catch(Exception e){
            System.out.println("Weird kind of set, no empty constructor");
            return null;
        }
    }
}
