package neuroml.model.cell;

import neuroml.core.*;
import neuroml.model.channel.*;

/** 
 * An arbitrary set of references to sections.<p>
 * This acts as a grouping mechanism for naming 
 * subsets of sections in a cell, useful for attaching
 * ion channels.<p>
 * This is incomplete - we need a way to specify scattering of
 * channels over the set.<p>
 */
public class SectionSet extends NamedObject {
    
    /** A set of ion channels in this section
     */
    public Set sections = new Set("Ref");

    public SectionSet() {
    }

    public SectionSet(String name) { 
	super(name);
    }

}
