/*
 * Channel.java
 *
 * Created on 19 August 2004, 16:31
 */

package neuroml.model.ions_channel;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public interface Channel extends java.io.Serializable {
 //modify the values of the channel depending on the current voltage of the soma
    boolean advance(double VoltageSoma, double dt);
    //Channels equation include a linear term depending on (u - Eion)
    //The intensity hoing trhough the neuron is assumed to be known.
    //Therefore we try to know u
    //It is basically the neuron which perform this operation, but to do so, the factor in front of (u - Eion need to be known)
    double getChannelCurrent(double VoltageSoma);
    
    double get_mORn();
    double get_h();
    Channel Clone();
}
