package neuroml.model.network;

import neuroml.core.*;

/** 
 * A 3D Grid structure
 */
public class Grid3DStructure extends PopulationStructure {   
    public int xsize=1;
    public int ysize=1;
    public int zsize=1;
    
    public Grid3DStructure() { super();
    }
    public Grid3DStructure(String name) {super(name); }

    public Grid3DStructure(String name, int xsize, int ysize) {
	super(name); 
	this.xsize = xsize;
	this.ysize = ysize; 
    }
    public Grid3DStructure(String name, int xsize, int ysize, int zsize) {
	super(name); 
	this.xsize = xsize;
	this.ysize = ysize;
	this.zsize = zsize; 
    }
}
