package neuroml.model.network;
 
import neuroml.core.*;
 
/** An Attachment specified as a list of connections
 */
public class RawAttachment extends Attachment {

    /** The connections to make
     */
    public List connections = new List("ProbeConnection");

    public RawAttachment() {
        super();
    }
    public RawAttachment(String name) {super(name); }
    
    public void copy(Connector pr){
         RawAttachment prt=(RawAttachment)pr;
         int size=prt.connections.size();
         for(int i=0;i<size;i++){
             connections.add(prt.connections.elementAt(i));
         }
    }   
   
}





