package neuroml.util;
 
/** Information about a list of objects - 
 * @see Namespace
 */
public class ListInfo {
    Object owner;     // Owner of list e.g. "CellPkg" instance
    String path;      // Path to object, e.g. "model.cells."
    String fieldName; // Name of list as fieldname, e.g. "modules"
    public ListInfo(Object o, String p, String f) {
	owner=o; path = p; fieldName=f;
    }
    public Object getOwner() { return owner; }
    public String getFieldName() { return fieldName; }
    public String getPath() { return path; }
}  
