/*
 * PlayerCallBack.java
 *
 * Created on 28 May 2004, 16:56
 */

package nmlplay;
import javax.swing.*;
import neuroml.sim.run.RunnableControl;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public interface PlayerCallBack {
    boolean isRunning();
    boolean isPaused();
    boolean isStopped();
    void showProgress(double t);
    void pause(double p);
    void stop();
    void runFinished( double nt );
    JPanel buildProbeRendering(String str);
    void SetRendering(RunnableControl path);
    RunnableControl getRendering();
    void println(String s);
}
