package MiscTests;

import java.io.*;
import java.net.*;

public class PingClient {
    public static void main(String[] args) throws IOException {
        Socket kkSocket = null;

	OutputStream os = null;
	InputStream is = null;
        try {
            kkSocket = new Socket(args[0], 4444);
	    os = kkSocket.getOutputStream();
	    is = kkSocket.getInputStream();

        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: taranis.");
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection to: taranis.");
            System.exit(1);
        }

        String fromServer;
        String fromUser;
	int sz = 3200;
	byte[] data = new byte[sz];
	for (int k=0; k<sz; k++) {
	    data[k] = (byte) (k % 256);
	}

	int i=0;
	int f;

	long t1 = System.currentTimeMillis();
        while (true) {
	    f = is.read();
	    if (f==0) break; // "ready".
	    
	    os.write(data);
	    //	    out.println(""+i);
	    i++;
        }
	long t2 = System.currentTimeMillis();
	System.out.println("Took "+(t2-t1)+" ms to send "+(i*sz/1000)+" kb");


        kkSocket.close();
    }
}
