package guikit; 
import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
import neuroml.model.network.*;
import neuroml.core.*;
import neuroml.util.*;
import java.util.*;



public class SubNetNode extends TreeNodeEditor {
  
    protected void defineChildNodes() {
        Population Obj;
                        
    // You must set the flag before defining children if you
    // use "add" for the new children. Otherwise you get an infinite
    // recursive loop, since add results in a call to getChildCount.
    // However, you could use "insert" in such a case.
        super.defineChildNodes();
        Obj=(SubNetwork)userObject;
        
        Hashtable temp = (Hashtable)((Hashtable)(ns.getReferences())).get("Network");
        Network myNet=(Network)temp.get(Obj.elementClass.getTargetName());
        Vector Elements=myNet.elements.getElements();
        for(int i=0;i<Elements.size();i++)
        {
            Obj=(Population)Elements.elementAt(i);

            if(Obj instanceof RealPopulation)
            {
                DefaultMutableTreeNode a = new DefaultMutableTreeNode(toString()+"."+Obj.getName()); 
                add(a);
            }
            else if(Obj instanceof SubNetwork)
            {
                SubNetNode a = new SubNetNode(); 
                a.setParameter(Obj,toString()+"."+Obj.getName());
                add(a);
            }       
        }
        
       // userObject
   }
    
    public String toString() {
        return super.toString();/*
        TreeNode parent = getParent();
        if(parent instanceof TreeNodeEditor)
        {
            return(parent.toString());
        }
        else
        {
            return(parent.toString());
        }*/
  }
    
      public DefaultMutableTreeNode SelectNode(Vector StackName, JTree myTree)
      {
        //InitSelect=true;
        //TreeNet.expandPath(new TreePath(this));
          Enumeration enum_=children();
          while(enum_.hasMoreElements())
          {
              DefaultMutableTreeNode a=(DefaultMutableTreeNode)enum_.nextElement();
                           
              if(a.toString().compareTo(StackName.elementAt(0).toString())==0) 
                  return a;
              else
              {
                  if(a instanceof SubNetNode)
                  {
                      if(StackName.contains(a.toString()))
                      {
                          myTree.expandPath(new TreePath(a.getPath()));
                          return ((SubNetNode)a).SelectNode(StackName, myTree);
                      }
                  }
              }
           }
          return null;
      }
}
