

package neosim.implementation;
import neosim.iface.*;

/** A population view provides a way of referring to
a collection of existing entities. It is specified 
by providing a population and a method to decide 
whether to add each entity to the view.  A typical view
would be a grid based decomposition which provides
a method to look up all entities in a given grid square.
 */
public class PopulationViewImpl extends PopulationImpl implements PopulationView {
    
    Population srcPop;

    /** Build size instances of entity class ec.
     * @param name the population name
     */
    public PopulationViewImpl( String name,  Population srcPop ) {//SOCKET_ERROR PopulationNode parent,
	super(name,0);//SOCKET_ERROR//, parent
	this.srcPop = srcPop;
    }
    
    /** Override this method to build new types of view 
     */
    public void buildView( Entity e ) {
	// if e fits the view, addEntityToView(e.getID());
	// *** constructView method will need to allgather the members of the view.
    }

    /** Call this method from within the buildView method
     * to add an entity to the view
     */
    public final void addEntityToView( int e ) {//EntityID
	addMember( e ); 
    }
}
