package neosim.kernel;



/** Used by server to notify other clients that a new 
 * client has joined
 */
public class AddCommand extends CommandObj {
  String name;
  RmtApp obj;
    public final String getType() { return "Add Command"; }
  public AddCommand(int id, String name, RmtApp obj) {  
      super(id); this.name = name; this.obj=obj;
  }
  public final void doit(SimKernel hp) {  
      //     System.out.println("~~~ Add command about to doit"+id);
      hp.addRmt(id,name,obj);  
      //      System.out.println("~~~ Add command doneit"+id);
  }
  public int getSize(){
      return 100;//not true but it is not very important
  }    
}
