package neosim.kernel;

import java.util.Vector;

/** Interface for collective communications 
 * Implemented by SimKernel for immediate use
 * Also implemented in terms of events by SysEntCommand for use
 * during a simulation.
 */
public interface Collective {
    public Vector allgather(Object o) throws ResetException;
    public Vector allgatherv(Vector v) throws ResetException;
} 
