package neosim.kernel;
import neosim.iface.*;

/** An Output Connection to a particular processor.
 */
public class OutPort implements java.io.Serializable {
    int proc;    // Dest processor
    int nconns;  // Number of output connections
    public OutPort(int proc) {
	this.proc   = proc;
	this.nconns = 1;
    }
    public final void addConnection() { nconns ++; }
    public final void removeConnection() { nconns --; }
    public final int numConnections() { return nconns; }
    //  public void send(SimKernel sk, double t, EntityID eid, PortID pid, Event ev) {
    //	sk.sendCommand( proc, new EventCommand(0, eid, cid, ev) );
    //    }
    public final int getProc() { return proc; }
}
