/*
 * QueryResponseTime.java
 *
 * Created on 14 December 2004, 15:43
 */

package neosim.kernel;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class QueryResponseTime extends QueryResponse implements java.io.Externalizable {   
    public int index=-1;
    /** Creates a new instance of QueryResponseTime */
    public QueryResponseTime(int id, int qid, Object res) {
        super(id,qid,res);
    }
    
    public QueryResponseTime(){
        super(0,0,new neosim.iface.Time());
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(id);
        objectOutput.writeInt(qid);   
        objectOutput.writeBoolean(blocking);
        objectOutput.writeLong(((neosim.iface.Time)res).t);        
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        id=objectInput.readInt();
        qid=objectInput.readInt(); 
        blocking=objectInput.readBoolean();
        ((neosim.iface.Time)res).t=objectInput.readLong();
    }
    
}
