package neosim.kernel;

/** Used by server to restart clients after barrier
 */
public class RestartCommand extends CommandObj {
  public RestartCommand(int id) {  
    super(id);
  }
  public final void doit(SimKernel sk) {  
      sk.restartRmt(id); 
      System.out.println("Restart");
  }
    public final String getType() { return "Restart Command"; }
    
    public int getSize(){
        return 15;
    }      
}

/*public class RestartCommand extends QueryCommand {
    public String getType() { return "RestartCommand Command"; }
    public RestartCommand(int id) { 
	super(id); 
	setBlocking(true);
    }
    public void doit(SimKernel sk, Collective comms) throws ResetException {  
	sk.restartRmt(id);
	if (needResponse()) sk.sendCommand(id, new QueryResponse(sk.getID(), qid, new Integer(0)));
    }
}*/
