package neosim.kernel;

import java.rmi.*;
import neosim.iface.Time;

/** Theinterface to remote ProcManager
 */
public interface RmtProcMgr extends java.rmi.Remote {
    RmtProc getProcessor(int i) throws java.rmi.RemoteException;
    void setSleeping(RmtProc p) throws java.rmi.RemoteException;
    void setRunning(RmtProc p, Time rw) throws java.rmi.RemoteException;
    void setStopped(RmtProc p) throws java.rmi.RemoteException;
    Time getMinTime() throws java.rmi.RemoteException;
    void setMinTime(Time t) throws java.rmi.RemoteException;
    void updateMinTime(Time rw) throws java.rmi.RemoteException;
    void calcMinTime() throws java.rmi.RemoteException;
}
