/*
 * MeasurementQuery.java
 *
 * Created on 10 September 2004, 15:52
 */

package neosim.neuroml;
import neosim.iface.*;
import neuroml.model.MeasurementTool.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class MeasurementQuery extends EntityQuery{
    MeasurementCollection MeasurementList;
    
    public MeasurementQuery(MeasurementCollection MeasurementList){
        this.MeasurementList=MeasurementList;
    }
    /** Creates a new instance of MeasurementQuery */
    public final Object query(Entity e) {
    try {
	    NeosimEntityImpl e2 = (NeosimEntityImpl) e;
            e2.setMeasured(MeasurementList);
            return MeasurementList;
	} catch (ClassCastException ex) { 
	    System.out.println("GetPos: Not an entity3D but a "+e.getClass().getName() + " name: "+e.getName()+" id: "+e.getID() );    
	}    
        return null;
    }
    
}
