/*
 * AllgatherV.java
 *
 * Created on 10 March 2005, 17:13
 */

package neosim.rmikernel;
import java.util.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class AllgatherV {
    int narrived=0;
    int ntot;
    Vector v;
    

    /** Creates a new instance of AllgatherV */
    public AllgatherV(int ntot) {
        this.ntot=ntot;
        v=new Vector();
        for(int i=0;i<ntot;i++)
            v.add(new Integer(-1));        
    }
    
    public synchronized Vector gather(Object o){
        v.setElementAt(o,narrived);
        narrived++;
        if(narrived==ntot){
            notifyAll();
            narrived=0;
        }
        else{
            try{
               wait();
            }
            catch(java.lang.InterruptedException e){
                System.out.println("Error "+narrived);
                e.printStackTrace();
            }
        }
        return v;        
    }
}
