/** Basic application.
 * Use as the base class for a user script reader,
 * by providing a bootstrap() method.
 */

package neosim.util;

import neosim.kernel.*;
import neosim.implementation.*;
import neosim.seqkernel.*;
import neosim.rmikernel.*;
import neosim.thrkernel.*;

import java.awt.*;
import java.rmi.*;
import java.util.Vector;
import java.rmi.server.*;


/** 
 * A basic application 
 * 
 */
public class BasicApp extends ScriptReaderImpl
{

    public static void main(String args[]) {
	System.out.println("=== NEOSIM Basic Application version 1.0 ===");
	BasicApp ap = new BasicApp();
	ap.initKernel(args);

	if (ap.needToConstruct()) {
	    ap.initSim(); /** fwh added Apr 00 */
	    ap.bootstrap(args);	  
	    ap.destroyKernel();
	}	
    }
}
 
