/*
 * LinkedList.java
 *
 * Created on 11 February 2005, 16:57
 */

package neosim.util.SmallLists;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public abstract class LinkedList {
    protected int RealIndex_read=0;
    protected int ListSize=50;
    protected static int TotalMemoryLinkedLists;
    protected static int NextCompressionStep;
    protected static int SizePerStep;

    public abstract void compress(); 
    
    public abstract void compress_final(); 
    /**
     * Get the memory size of the object
     */
    public abstract int getSize();
    public static synchronized boolean checkCompression(LinkedList obj){
        if(TotalMemoryLinkedLists>NextCompressionStep){
            System.out.println("Compress at "+TotalMemoryLinkedLists);            
            obj.compress();
            NextCompressionStep+=SizePerStep;
            return true;
        }
        return false;
    }
     public static synchronized void clear(){
        TotalMemoryLinkedLists=0;
        SizePerStep=67108864;//50Mb
        NextCompressionStep=SizePerStep;
     }
}
