
package neosim.util;
  
/** The trace command types.
 * @see interact.TraceListener
 * @see interact.TraceEventObject
 */
public interface Traceable {
  /** A single trace line command */
  static final int TRACE  = 0;
  /** The user has pressed Layout */
  static final int LAYOUT = 1;
  /** The user has pressed Run */
  static final int RUN    = 2;
  /** The user has pressed Pause */
  static final int PAUSE  = 3;
  /** The user has pressed Stop */
  static final int STOP   = 4;
  /** Update the display */
  static final int DISPLAY= 5;
  /** Integer Value */
  static final int INTVAL = 6;
}
