package neuroml.core;

/* Module location.
 * @see ModuleRef for a reference to a module
 */
public class Module extends NamedObject {

    /** Location of the module (URL)
     */
    public String location="";

    /** (optionnal) main class of the module
     */
    public String className=null;

    

    /** The module's image icon
     */
    public String imageUrl="";

    /** The module's documentation URL
     */
    public String docUrl="";
    
    /** The object ... just used by the editor for now
     */
    Object moduleObject=null;

    public Object getModuleObject() { 
	return moduleObject;
    }
    public void setModuleObject(Object o) {
	moduleObject = o;
    }

    public Module(String name) {
	super(name);
    }

    public Module() {      
    }

}
