package neuroml.core;

/** An interface a reference implements.
 * @see Ref for a sample implementation
 */
public interface Reference {
    /** Gets the target reference name, 
     * using dot notation
     * @return the reference target
     */
    public String getTargetName();

    /** Sets the target reference name, 
     * using dot notation
     * @param n the reference target name
     */
    public void setTargetName(String n);
}
