package neuroml.data;

import neuroml.core.*;

/**
 * A train of spikes : a list of timestamps
 */
public class SpikeTrain extends NamedObject{  
    public DoubleArray spikeTimes;

    public  SpikeTrain(){
	Ref unit = new Ref("Unit");
	unit.setTargetName( "ms" );
	spikeTimes = new DoubleArray(unit);
    }
}
