/*
 * AverageSynapseIntensity.java
 *
 * Created on 19 October 2004, 16:52
 */

package neuroml.model.MeasurementTool;
import neuroml.model.Synapse_nml.*;
import neuroml.sim.run.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class AverageSynapseIntensity extends MeasurementTool {
    
    /** Creates a new instance of AverageSynapseIntensity */
    public AverageSynapseIntensity() {
        super();
    }
    public double getValue(RunnableCell myCell, double t) {
        return ((SynapticCell)myCell).getAverageIntensitySynapse();
    }
    public String toString(){
        String toAdd;
        if(this.ToBeSent)
            toAdd=new String();
        else
            toAdd=new String("NOT_");
        return toAdd+"AvSynIntensity";
    }
    public String getXUnit(){
        return "Time(s)";
    }
    public String getYUnit(){
        return "Intensity(A)";
        
    }    
    
    public Object Clone() {
        return new AverageSynapseIntensity();
    }    
}
