/*
 * ModuleMeasurement.java
 *
 * Created on 18 October 2004, 17:28
 */

package neuroml.model.MeasurementTool;
import neuroml.core.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class ModuleMeasurement extends NamedObject {
    public ModuleRef module = new ModuleRef();    
    /** Creates a new instance of ModuleMeasurement */
    public ModuleMeasurement() {
        super();
        module = new ModuleRef();
        module.setName(getClass().getName()+"."+"module");        
    }
    
    public String toString(){
        Object o = module.parameters;
        if (o != null)
            return o.toString();
        else
            return super.toString();
    }
    
    public String getName() { 
        if(name==null||name.length()<1)
            name=toString();
        return name; 
    }
 
}
