/*
 * SynapticCell.java
 *
 * Created on 19 August 2004, 16:34
 */

package neuroml.model.Synapse_nml;
import java.util.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public interface SynapticCell {
    public void addSynapse(Synapse myNewSynapse, int SendingNeuronId);
    public Synapse getSynapse(int i);
    public Synapse getSynapse(int i,Class ClassName);        
    public Synapse[] getSynapses();
    public Vector getSynapses(Class ClassName);
    public double getIntensitySynapse(int i);
    public double getIntensitySynapse(int i,Class ClassName);    
    public double getAverageIntensitySynapse();
    public double getAverageIntensitySynapse(Class ClassName);
}
