package neuroml.model.channel;

import neuroml.core.*;


/** Top level class for solutions of ions/molecules
 */
public class Solution extends NamedObject {

    public String ionName = "Na";
    public int valency = 1;
    public DValue initialConcentration = new DValue(0, "mol");

    public Solution() {
    }

    public Solution(String name) {
	super(name);
    }
}
