package neuroml.model.ions_channel;

import neuroml.core.*;

/** Top level class for channels.
 * @author Fred Howell, Robert Cannon
 * @date March 2001
 */
public class Ions_channelPkg extends Pkg {
   
    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = {
	    "Channel",
	    "ChannelPkg",
	    "ChannelCell",
            "ModuleChannel"
	};
	return ret;
    }
}
