/*
 * RealPopulation.java
 *
 * Created on 12 January 2004, 11:16
 */

package neuroml.model.network;
import neuroml.core.*;
import neuroml.model.I_Clamp.*;
/*
 *
 * @author  Jean-Alain Grunchec
 * JAG
 * RealPopulation replaces Population.
 * Population becomes a superclass for both RealPopulation and SubNetwork
 * 
 */
public class RealPopulation extends Population {
      
    public PopulationStructure structure;
    public Module_I_Clamp ExternalIntensity=new Module_I_Clamp();    
    public RealPopulation() {
	structure = new Grid1DStructure("structure", 1);
        elementClass=new Ref("ElementPopulation");
    }
    
    public RealPopulation(String string) {
	super(string);
	structure = new Grid1DStructure("structure", 1);
        elementClass=new Ref("ElementPopulation");
    }
    
    public RealPopulation(String string, String string_0_) {
	super(string, string_0_);
	structure = new Grid1DStructure("structure", 1);
//        elementClass=new Ref("ElementPopulation");
    }
    
    public RealPopulation(String string, String string_1_, int i) {
	super(string, string_1_);
	structure = new Grid1DStructure("structure", 1);
	structure = new Grid1DStructure("structure", i);
//        elementClass=new Ref("ElementPopulation");
    }
    
    public void setPopulationStructure
	(PopulationStructure populationstructure) {
	structure = populationstructure;
    }
}
