/*
 * SubNetwork.java
 *
 * Created on 12 January 2004, 11:22
 */

package neuroml.model.network;
import neuroml.core.*;
/**
 *
 * @author  Jean-Alain Grunchec
 * SubNetwork is a reference to a network, a copy of a network, or an instance  of another network (which is considered as a class).
 * 
 */
public class SubNetwork extends Population {  
    public boolean Probes=false;
    /** Creates a new instance of SubNetwork */
    public SubNetwork() {
        elementClass=new Ref("ElementNetwork");
    }
    
    public SubNetwork(String string) {
	super(string);
        elementClass=new Ref("ElementNetwork");
    }
    
    public SubNetwork(String string, String string_0_) {
	super(string, string_0_);
        elementClass=new Ref("ElementNetwork");
    }
    
}
