package neuroml.sim;

 
/** Interface for updating elements of a list
 */
public interface ElementChangedListener {  
    
    /** Call when the object changes
     */
    void elementChanged(Object oldobject, Object newobject);

   /** Call when the object's change is confirmed
     */
    void confirmElementChanged(Object oldobject, Object newobject);
}
 
