package neuroml.sim.run;
 
import neuroml.sim.state.*;
import java.util.*;


/** A runnable control module.
 * Modules implementing the run method can control the simulation
 * progress via the Simulator interface.
 */
public interface RunnableControl {
    /** Run this control module.
     * @param sr the calling simulator
     */
    public void run( Simulator sr );
}
