package neuroml.sim.run;
 
import neuroml.sim.state.*;

/** Interface for sending spikes
 */
public interface SpikeSender {

    /** Send a spike on a given output */
    public void sendSpike(double t, short outputConnection);

    /** Send an object on a given output */
    public void send(Object o, double t, short outputConnection);
    
    public void sendDelayed(Object o, double t, short outputConnection);

}
