package neuroml.sim.state;


/** Interface to return 3D position.
 */
public interface PositionState {  
    public void setPos(double x, double y, double z);
    public double getXPos();    
    public double getYPos();    
    public double getZPos();
    public void setShape( Shape s );
    public Shape getShape();
    public void draw();
}
