package neuroml.util.schema;

import neuroml.core.*; 
import neuroml.util.*; 
import neuroml.util.schema.*; 
import java.util.Vector;

/** 
 * NeuromlSchema version of a "Vector"
 */
public class NeuromlVector extends NeuromlObject {
    public Vector elements;
    public String elementType;
    public NeuromlVector(Vector els, String fieldname, String fieldtype) { 	
	elements = els; 
	setPath(fieldname);
	elementType = fieldtype;
    }
    public Vector getElements() { return elements; }
    public String getElementType() { return elementType; }
}

